"use strict";

exports.__esModule = true;
exports.default = void 0;

var _errorLogging = _interopRequireDefault(require("./error-logging"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _default = {
  ErrorLogging: _errorLogging.default,
  registerServices: function registerServices(serviceFactory) {
    serviceFactory.registerServiceCreator('ErrorLogging', function () {
      var apmService = serviceFactory.getService('ApmServer');
      var configService = serviceFactory.getService('ConfigService');
      var transactionService = serviceFactory.getService('TransactionService');
      return new _errorLogging.default(apmService, configService, transactionService);
    });
  }
};
exports.default = _default;