"use strict";

exports.__esModule = true;
exports.default = void 0;

var _performanceMonitoring = _interopRequireDefault(require("./performance-monitoring"));

var _transactionService = _interopRequireDefault(require("./transaction-service"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _default = {
  PerformanceMonitoring: _performanceMonitoring.default,
  registerServices: function registerServices(serviceFactory) {
    serviceFactory.registerServiceCreator('TransactionService', function () {
      var configService = serviceFactory.getService('ConfigService');
      var loggingService = serviceFactory.getService('LoggingService');
      return new _transactionService.default(loggingService, configService);
    });
    serviceFactory.registerServiceCreator('PerformanceMonitoring', function () {
      var configService = serviceFactory.getService('ConfigService');
      var loggingService = serviceFactory.getService('LoggingService');
      var apmService = serviceFactory.getService('ApmServer');
      var transactionService = serviceFactory.getService('TransactionService');
      return new _performanceMonitoring.default(apmService, configService, loggingService, transactionService);
    });
  }
};
exports.default = _default;