"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var rect_1 = require("../primitives/rect");
var d3_utils_1 = require("../../../../partition_chart/layout/utils/d3_utils");
var canvas_1 = require("../../../../../renderers/canvas");
function renderRectAnnotations(ctx, annotations, rectStyle) {
    var rects = annotations.map(function (annotation) {
        return annotation.rect;
    });
    var fillColor = d3_utils_1.stringToRGB(rectStyle.fill);
    fillColor.opacity = fillColor.opacity * rectStyle.opacity;
    var fill = {
        color: fillColor,
    };
    var strokeColor = d3_utils_1.stringToRGB(rectStyle.stroke);
    strokeColor.opacity = strokeColor.opacity * rectStyle.opacity;
    var stroke = {
        color: strokeColor,
        width: rectStyle.strokeWidth,
    };
    var rectsLength = rects.length;
    var _loop_1 = function (i) {
        var rect = rects[i];
        canvas_1.withContext(ctx, function (ctx) {
            rect_1.renderRect(ctx, rect, fill, stroke);
        });
    };
    for (var i = 0; i < rectsLength; i++) {
        _loop_1(i);
    }
}
exports.renderRectAnnotations = renderRectAnnotations;
//# sourceMappingURL=rect.js.map