"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var arc_1 = require("./primitives/arc");
var point_1 = require("./styles/point");
function renderPoints(ctx, points, themeStyle, geometryStateStyle) {
    return points.map(function (point) {
        var x = point.x, y = point.y, color = point.color, transform = point.transform, styleOverrides = point.styleOverrides;
        var _a = point_1.buildPointStyles(color, themeStyle, geometryStateStyle, styleOverrides), fill = _a.fill, stroke = _a.stroke, radius = _a.radius;
        var circle = {
            x: x + transform.x,
            y: y,
            radius: radius,
        };
        arc_1.renderCircle(ctx, circle, fill, stroke);
    });
}
exports.renderPoints = renderPoints;
//# sourceMappingURL=points.js.map