"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var d3_utils_1 = require("../../../../partition_chart/layout/utils/d3_utils");
function buildBarStyles(baseColor, themeRectStyle, themeRectBorderStyle, geometryStateStyle) {
    var fillColor = d3_utils_1.stringToRGB(themeRectStyle.fill || baseColor);
    var fillOpacity = themeRectStyle.opacity * geometryStateStyle.opacity;
    fillColor.opacity = fillOpacity;
    var fill = {
        color: fillColor,
    };
    var strokeColor = d3_utils_1.stringToRGB(themeRectBorderStyle.stroke || baseColor);
    var defaultStrokeOpacity = themeRectBorderStyle.strokeOpacity === undefined ? themeRectStyle.opacity : themeRectBorderStyle.strokeOpacity;
    var borderStrokeOpacity = defaultStrokeOpacity * geometryStateStyle.opacity;
    strokeColor.opacity = strokeColor.opacity * borderStrokeOpacity;
    var stroke = {
        color: strokeColor,
        width: themeRectBorderStyle.visible ? themeRectBorderStyle.strokeWidth : 0,
    };
    return { fill: fill, stroke: stroke };
}
exports.buildBarStyles = buildBarStyles;
//# sourceMappingURL=bar.js.map