"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var d3_utils_1 = require("../../../../partition_chart/layout/utils/d3_utils");
var commons_1 = require("../../../../../utils/commons");
function buildPointStyles(baseColor, themePointStyle, geometryStateStyle, overrides) {
    var pointStyle = commons_1.mergePartial(themePointStyle, overrides);
    var fillColor = d3_utils_1.stringToRGB(pointStyle.fill || baseColor);
    fillColor.opacity = fillColor.opacity * pointStyle.opacity * geometryStateStyle.opacity;
    var fill = {
        color: fillColor,
    };
    var strokeColor = d3_utils_1.stringToRGB(pointStyle.stroke || baseColor);
    strokeColor.opacity = strokeColor.opacity * pointStyle.opacity * geometryStateStyle.opacity;
    var stroke = {
        color: strokeColor,
        width: pointStyle.strokeWidth,
    };
    var radius = overrides && overrides.radius ? overrides.radius : themePointStyle.radius;
    return { fill: fill, stroke: stroke, radius: radius };
}
exports.buildPointStyles = buildPointStyles;
//# sourceMappingURL=point.js.map