"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var re_reselect_1 = __importDefault(require("re-reselect"));
var get_chart_rotation_1 = require("../../../../state/selectors/get_chart_rotation");
var compute_chart_dimensions_1 = require("./compute_chart_dimensions");
var get_chart_id_1 = require("../../../../state/selectors/get_chart_id");
var getMouseDownPosition = function (state) { return state.interactions.pointer.down; };
var getCurrentPointerPosition = function (state) {
    return state.interactions.pointer.current.position;
};
exports.getBrushAreaSelector = re_reselect_1.default([getMouseDownPosition, getCurrentPointerPosition, get_chart_rotation_1.getChartRotationSelector, compute_chart_dimensions_1.computeChartDimensionsSelector], function (mouseDownPosition, cursorPosition, chartRotation, _a) {
    var chartDimensions = _a.chartDimensions;
    if (!mouseDownPosition) {
        return null;
    }
    var brushStart = {
        x: mouseDownPosition.position.x,
        y: mouseDownPosition.position.y,
    };
    if (chartRotation === 0 || chartRotation === 180) {
        var area = {
            left: brushStart.x - chartDimensions.left,
            width: cursorPosition.x - brushStart.x,
            top: 0,
            height: chartDimensions.height,
        };
        return area;
    }
    else {
        var area = {
            left: 0,
            width: chartDimensions.width,
            top: brushStart.y - chartDimensions.top,
            height: cursorPosition.y - brushStart.y,
        };
        return area;
    }
})(get_chart_id_1.getChartIdSelector);
//# sourceMappingURL=get_brush_area.js.map