"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.EuiErrorBoundary = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _text = require("../text");

var EuiErrorBoundary =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2.default)(EuiErrorBoundary, _Component);

  function EuiErrorBoundary(props) {
    var _this;

    (0, _classCallCheck2.default)(this, EuiErrorBoundary);
    _this = (0, _possibleConstructorReturn2.default)(this, (0, _getPrototypeOf2.default)(EuiErrorBoundary).call(this, props));
    var errorState = {
      hasError: false,
      error: undefined
    };
    _this.state = errorState;
    return _this;
  }

  (0, _createClass2.default)(EuiErrorBoundary, [{
    key: "componentDidCatch",
    value: function componentDidCatch(error) {
      // Display fallback UI
      this.setState({
        hasError: true,
        error: error
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          children = _this$props.children,
          rest = (0, _objectWithoutProperties2.default)(_this$props, ["children"]);

      if (this.state.hasError) {
        // You can render any custom fallback UI
        return _react.default.createElement("div", (0, _extends2.default)({
          className: "euiErrorBoundary"
        }, rest), _react.default.createElement("div", {
          className: "euiErrorBoundary__text"
        }, _react.default.createElement(_text.EuiText, {
          size: "xs"
        }, _react.default.createElement("h1", null, "Error"), _react.default.createElement("pre", {
          className: "euiErrorBoundary__stack"
        }, _react.default.createElement("p", null, this.state.error && this.state.error.stack)))));
      }

      return children;
    }
  }]);
  return EuiErrorBoundary;
}(_react.Component);

exports.EuiErrorBoundary = EuiErrorBoundary;
(0, _defineProperty2.default)(EuiErrorBoundary, "propTypes", {
  children: _propTypes.default.node
});
EuiErrorBoundary.propTypes = {
  className: _propTypes.default.string,
  "aria-label": _propTypes.default.string,
  "data-test-subj": _propTypes.default.string
};
EuiErrorBoundary.__docgenInfo = {
  "description": "",
  "methods": [],
  "displayName": "EuiErrorBoundary",
  "props": {
    "children": {
      "type": {
        "name": "node"
      },
      "required": false,
      "description": ""
    }
  }
};