"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.EuiFlyoutBody = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var EuiFlyoutBody = function EuiFlyoutBody(_ref) {
  var children = _ref.children,
      className = _ref.className,
      banner = _ref.banner,
      rest = (0, _objectWithoutProperties2.default)(_ref, ["children", "className", "banner"]);
  var classes = (0, _classnames.default)('euiFlyoutBody', className);
  var overflowClasses = (0, _classnames.default)('euiFlyoutBody__overflow', {
    'euiFlyoutBody__overflow--hasBanner': banner
  });
  return _react.default.createElement("div", (0, _extends2.default)({
    className: classes
  }, rest), _react.default.createElement("div", {
    className: overflowClasses
  }, banner && _react.default.createElement("div", {
    className: "euiFlyoutBody__banner"
  }, banner), _react.default.createElement("div", {
    className: "euiFlyoutBody__overflowContent"
  }, children)));
};

exports.EuiFlyoutBody = EuiFlyoutBody;
EuiFlyoutBody.propTypes = {
  className: _propTypes.default.string,
  "aria-label": _propTypes.default.string,
  "data-test-subj": _propTypes.default.string,

  /**
         * Use to display a banner at the top of the body. It is suggested to use `EuiCallOut` for it.
         */
  banner: _propTypes.default.node
};
EuiFlyoutBody.__docgenInfo = {
  "description": "",
  "methods": [],
  "displayName": "EuiFlyoutBody",
  "props": {
    "className": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": ""
    },
    "aria-label": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": ""
    },
    "data-test-subj": {
      "type": {
        "name": "string"
      },
      "required": false,
      "description": ""
    },
    "banner": {
      "type": {
        "name": "node"
      },
      "required": false,
      "description": "Use to display a banner at the top of the body. It is suggested to use `EuiCallOut` for it."
    }
  }
};